"""Add actions table

Revision ID: b8fe6f5e834f
Revises: 27133ce191df
Create Date: 2023-05-16 12:27:44.136685

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "b8fe6f5e834f"
down_revision = "27133ce191df"
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "actions",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("performer_id", sa.Integer(), nullable=False),
        sa.Column("target_id", sa.Integer(), nullable=False),
        sa.Column("description", sa.String(length=64), nullable=True),
        sa.Column("timestamp", sa.Float(), nullable=False),
        sa.ForeignKeyConstraint(
            ["performer_id"],
            ["users.id"],
        ),
        sa.ForeignKeyConstraint(
            ["target_id"],
            ["users.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("actions")
    # ### end Alembic commands ###
